/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern0 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 2;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != 19)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  return 0;
}

int
pattern18 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 7;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 8;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 33
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern57 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[3], i1)
      || !contiguous_bitmask_nowrap_operand (operands[2], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_TDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 0;

        case E_FPRX2mode:
          return 1;

        case E_DFmode:
          return 2;

        case E_SFmode:
          return 3;

        default:
          return -1;
        }

    case E_DDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 4;

        case E_FPRX2mode:
          return 5;

        case E_DFmode:
          return 6;

        case E_SFmode:
          return 7;

        default:
          return -1;
        }

    case E_SDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 8;

        case E_FPRX2mode:
          return 9;

        case E_DFmode:
          return 10;

        case E_SFmode:
          return 11;

        default:
          return -1;
        }

    case E_TFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 12;

        case E_DDmode:
          return 13;

        case E_SDmode:
          return 14;

        default:
          return -1;
        }

    case E_FPRX2mode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_FPRX2mode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 15;

        case E_DDmode:
          return 16;

        case E_SDmode:
          return 17;

        default:
          return -1;
        }

    case E_DFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 18;

        case E_DDmode:
          return 19;

        case E_SDmode:
          return 20;

        default:
          return -1;
        }

    case E_SFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 21;

        case E_DDmode:
          return 22;

        case E_SDmode:
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern108 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 8:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT
          || !register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L
              || XWINT (x9, 0) != 4L
              || XWINT (x10, 0) != 5L
              || XWINT (x11, 0) != 6L
              || XWINT (x12, 0) != 7L)
            return -1;
          return 0;

        case 8L:
          if (XWINT (x6, 0) != 9L
              || XWINT (x7, 0) != 10L
              || XWINT (x8, 0) != 11L
              || XWINT (x9, 0) != 12L
              || XWINT (x10, 0) != 13L
              || XWINT (x11, 0) != 14L
              || XWINT (x12, 0) != 15L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L)
            return -1;
          return 2;

        case 4L:
          if (XWINT (x6, 0) != 5L
              || XWINT (x7, 0) != 6L
              || XWINT (x8, 0) != 7L)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L)
            return -1;
          return 4;

        case 2L:
          if (XWINT (x6, 0) != 3L)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1QImode:
          return 0;

        case E_V2QImode:
          return 1;

        case E_V4QImode:
          return 2;

        case E_V8QImode:
          return 3;

        case E_V16QImode:
          return 4;

        default:
          return -1;
        }

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1HImode:
          return 5;

        case E_V2HImode:
          return 6;

        case E_V4HImode:
          return 7;

        case E_V8HImode:
          return 8;

        default:
          return -1;
        }

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SImode:
          return 9;

        case E_V2SImode:
          return 10;

        case E_V4SImode:
          return 11;

        default:
          return -1;
        }

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1DImode:
          return 12;

        case E_V2DImode:
          return 13;

        default:
          return -1;
        }

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SFmode:
          return 14;

        case E_V2SFmode:
          return 15;

        case E_V4SFmode:
          return 16;

        default:
          return -1;
        }

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1DFmode:
          return 17;

        case E_V2DFmode:
          return 18;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern186 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern197 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != USE)
    return -1;
  return 0;
}

int
pattern202 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 4
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_CCUmode))
    return -1;
  return 0;
}

int
pattern222 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode)
          || !scratch_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TFmode)
          || !scratch_operand (operands[2], E_V1TImode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode)
          || !scratch_operand (operands[2], E_TImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern253 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern271 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !nonsym_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern287 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[2] = x3;
  if (!memory_operand (operands[2], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 73; /* vstlv1qi */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 74; /* vstlv2qi */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 75; /* vstlv4qi */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 76; /* vstlv8qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 77; /* vstlv16qi */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 78; /* vstlv1hi */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 79; /* vstlv2hi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 80; /* vstlv4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 81; /* vstlv8hi */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 82; /* vstlv1si */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 83; /* vstlv2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 84; /* vstlv4si */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 85; /* vstlv1di */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 86; /* vstlv2di */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 87; /* vstlv1sf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 88; /* vstlv2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 89; /* vstlv4sf */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 90; /* vstlv1df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 91; /* vstlv2df */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 62:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !memory_operand (operands[1], E_QImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 5; /* vec_insert_and_zerov16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !memory_operand (operands[1], E_HImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 6; /* vec_insert_and_zerov8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !memory_operand (operands[1], E_SImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 7; /* vec_insert_and_zerov4si */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !memory_operand (operands[1], E_DImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 8; /* vec_insert_and_zerov2di */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !memory_operand (operands[1], E_DFmode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 9; /* vec_insert_and_zerov2df */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !memory_operand (operands[1], E_SFmode)
              || !(
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 27 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
            return -1;
          return 10; /* vec_insert_and_zerov4sf */

        default:
          return -1;
        }

    case 74:
      switch (pattern47 (x3))
        {
        case 0:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 70; /* vec_extendv16qi */

        case 1:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 71; /* vec_extendv8hi */

        case 2:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 72; /* vec_extendv4si */

        default:
          return -1;
        }

    case 78:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 94; /* vec_unpackhv16qi */

        case 1:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 95; /* vec_unpackhv8hi */

        case 2:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 96; /* vec_unpackhv4si */

        case 3:
          if (!(
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 97; /* vec_unpackhv2di */

        default:
          return -1;
        }

    case 79:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 98; /* vec_unpackh_lv16qi */

        case 1:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 99; /* vec_unpackh_lv8hi */

        case 2:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 100; /* vec_unpackh_lv4si */

        case 3:
          if (!(
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 101; /* vec_unpackh_lv2di */

        default:
          return -1;
        }

    case 80:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 102; /* vec_unpacklv16qi */

        case 1:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 103; /* vec_unpacklv8hi */

        case 2:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 104; /* vec_unpacklv4si */

        case 3:
          if (!(
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 105; /* vec_unpacklv2di */

        default:
          return -1;
        }

    case 81:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 106; /* vec_unpackl_lv16qi */

        case 1:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 107; /* vec_unpackl_lv8hi */

        case 2:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 108; /* vec_unpackl_lv4si */

        case 3:
          if (!(
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 109; /* vec_unpackl_lv2di */

        default:
          return -1;
        }

    case 116:
      switch (pattern47 (x3))
        {
        case 0:
          if (!
#line 1502 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 377; /* vistrv16qi */

        case 1:
          if (!
#line 1502 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 378; /* vistrv8hi */

        case 2:
          if (!
#line 1502 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 379; /* vistrv4si */

        default:
          return -1;
        }

    case 127:
      if (GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[0], E_V2DFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 1854 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 403; /* vflls */

    case 136:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 2283 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 515; /* vgemv16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2292 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 516; /* vgemv8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2292 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 517; /* vgemv4si */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2292 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 518; /* vgemv2di */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2292 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 519; /* vgemv1ti */

        case E_TImode:
          if (!register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2292 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 520; /* vgemti */

        default:
          return -1;
        }

    case 137:
      if (GET_MODE (x3) != E_FPRX2mode
          || !register_operand (operands[0], E_FPRX2mode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!general_operand (operands[1], E_TFmode)
          || !
#line 931 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 677; /* tf_to_fprx2 */

    case 37:
      return recog_1 (x1, insn, pnum_clobbers);

    case 40:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1533; /* floorv4sf2 */

        case 1:
          if (!
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1538; /* floorv2df2 */

        case 2:
          if (!(
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1543; /* floorv1tf2 */

        case 3:
          if ((
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1548; /* floortf2_vr */
          if (!(
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2106; /* floortf2_fpr */

        case 4:
          if (!(
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2111; /* floorfprx22 */

        case 5:
          if (!
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2116; /* floordf2 */

        case 6:
          if (!
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2121; /* floorsf2 */

        case 7:
          if (!
#line 5862 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2130; /* floortd2 */

        case 8:
          if (!
#line 5862 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2135; /* floordd2 */

        default:
          return -1;
        }

    case 41:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1534; /* btruncv4sf2 */

        case 1:
          if (!
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1539; /* btruncv2df2 */

        case 2:
          if (!(
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1544; /* btruncv1tf2 */

        case 3:
          if ((
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1549; /* btrunctf2_vr */
          if (!(
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2107; /* btrunctf2_fpr */

        case 4:
          if (!(
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2112; /* btruncfprx22 */

        case 5:
          if (!
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2117; /* btruncdf2 */

        case 6:
          if (!
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2122; /* btruncsf2 */

        case 7:
          if (!
#line 5862 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2131; /* btrunctd2 */

        case 8:
          if (!
#line 5862 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2136; /* btruncdd2 */

        default:
          return -1;
        }

    case 42:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1535; /* roundv4sf2 */

        case 1:
          if (!
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1540; /* roundv2df2 */

        case 2:
          if (!(
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1545; /* roundv1tf2 */

        case 3:
          if ((
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1550; /* roundtf2_vr */
          if (!(
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2108; /* roundtf2_fpr */

        case 4:
          if (!(
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2113; /* roundfprx22 */

        case 5:
          if (!
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2118; /* rounddf2 */

        case 6:
          if (!
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2123; /* roundsf2 */

        case 7:
          if (!
#line 5862 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2132; /* roundtd2 */

        case 8:
          if (!
#line 5862 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2137; /* rounddd2 */

        default:
          return -1;
        }

    case 43:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1536; /* ceilv4sf2 */

        case 1:
          if (!
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1541; /* ceilv2df2 */

        case 2:
          if (!(
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1546; /* ceilv1tf2 */

        case 3:
          if ((
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1551; /* ceiltf2_vr */
          if (!(
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2109; /* ceiltf2_fpr */

        case 4:
          if (!(
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2114; /* ceilfprx22 */

        case 5:
          if (!
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2119; /* ceildf2 */

        case 6:
          if (!
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2124; /* ceilsf2 */

        case 7:
          if (!
#line 5862 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2133; /* ceiltd2 */

        case 8:
          if (!
#line 5862 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2138; /* ceildd2 */

        default:
          return -1;
        }

    case 44:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1537; /* nearbyintv4sf2 */

        case 1:
          if (!
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1542; /* nearbyintv2df2 */

        case 2:
          if (!(
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1547; /* nearbyintv1tf2 */

        case 3:
          if ((
#line 3065 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1552; /* nearbyinttf2_vr */
          if (!(
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2110; /* nearbyinttf2_fpr */

        case 4:
          if (!(
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2115; /* nearbyintfprx22 */

        case 5:
          if (!
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2120; /* nearbyintdf2 */

        case 6:
          if (!
#line 5836 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2125; /* nearbyintsf2 */

        case 7:
          if (!
#line 5862 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2134; /* nearbyinttd2 */

        case 8:
          if (!
#line 5862 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2139; /* nearbyintdd2 */

        default:
          return -1;
        }

    case 45:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 3082 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1553; /* rintv4sf2 */

        case 1:
          if (!
#line 3082 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1554; /* rintv2df2 */

        case 2:
          if (!(
#line 3082 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1555; /* rintv1tf2 */

        case 3:
          if ((
#line 3082 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1556; /* rinttf2_vr */
          if (!
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE))
            return -1;
          return 2126; /* rinttf2_fpr */

        case 4:
          if (!
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE))
            return -1;
          return 2127; /* rintfprx22 */

        case 5:
          return 2128; /* rintdf2 */

        case 6:
          return 2129; /* rintsf2 */

        case 7:
          if (!
#line 5872 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2140; /* rinttd2 */

        case 8:
          if (!
#line 5872 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2141; /* rintdd2 */

        default:
          return -1;
        }

    case 30:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (pattern80 (x3))
        {
        case 0:
          return 1842; /* *get_tp_31 */

        case 1:
          if (!
#line 2171 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1843; /* *get_tp_64 */

        default:
          return -1;
        }

    case 5:
      if (GET_MODE (x3) != E_SImode
          || !nonimmediate_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      return 1892; /* *cc_to_int */

    case 4:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_CCUmode))
        return -1;
      *pnum_clobbers = 1;
      return 1913; /* cmpint */

    case 20:
      if (GET_MODE (x3) != E_BLKmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 2586; /* mem_thread_fence_1 */

    case 21:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          if (register_operand (operands[0], E_DImode)
              && memory_operand (operands[1], E_DImode)
              && 
#line 11225 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2587; /* atomic_loaddi_1 */
          if (!memory_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 11272 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2589; /* atomic_storedi_1 */

        case E_TImode:
          if (GET_MODE (x3) != E_TImode)
            return -1;
          if (register_operand (operands[0], E_TImode)
              && memory_operand (operands[1], E_TImode)
              && 
#line 11239 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2588; /* atomic_loadti_1 */
          if (!memory_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 11286 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2590; /* atomic_storeti_1 */

        default:
          return -1;
        }

    case 15:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) != LABEL_REF
          || !register_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!
#line 11737 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2613; /* main_base_64 */

    case 14:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) != LABEL_REF
          || !register_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!
#line 11757 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2615; /* reload_base_64 */

    case 33:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 2623; /* stack_protect_setdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 2624; /* stack_protect_setsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      if (!general_operand (operands[1], E_FPRX2mode)
          || !nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !
#line 678 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 645; /* fprx2_to_tf */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 73
          || GET_MODE (x4) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_V16QImode)
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_V16QImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern289 (x2, 
E_V16QImode) != 0
              || !
#line 773 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 648; /* *vec_permv16qi */

        case E_V8HImode:
          if (pattern289 (x2, 
E_V8HImode) != 0
              || !
#line 773 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 649; /* *vec_permv8hi */

        case E_V4SImode:
          if (pattern289 (x2, 
E_V4SImode) != 0
              || !
#line 773 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 650; /* *vec_permv4si */

        case E_V2DImode:
          if (pattern289 (x2, 
E_V2DImode) != 0
              || !
#line 773 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 651; /* *vec_permv2di */

        case E_V2DFmode:
          if (pattern289 (x2, 
E_V2DFmode) != 0
              || !
#line 773 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 652; /* *vec_permv2df */

        case E_V1TImode:
          if (pattern289 (x2, 
E_V1TImode) != 0
              || !
#line 773 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 653; /* *vec_permv1ti */

        case E_TImode:
          if (pattern289 (x2, 
E_TImode) != 0
              || !
#line 773 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 654; /* *vec_permti */

        case E_V4SFmode:
          if (pattern289 (x2, 
E_V4SFmode) != 0
              || !(
#line 773 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 655; /* *vec_permv4sf */

        case E_V1TFmode:
          if (pattern289 (x2, 
E_V1TFmode) != 0
              || !(
#line 773 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 656; /* *vec_permv1tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      operands[1] = x3;
      if (address_operand (operands[1], E_QImode))
        {
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == CONST_INT
              && XWINT (x4, 0) == 2147483647L
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode)
            {
              if (
#line 2568 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return 1850; /* *la_31_and */
              if (pnum_clobbers != NULL
                  && 
#line 2582 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                {
                  *pnum_clobbers = 1;
                  return 1851; /* *la_31_and_cc */
                }
            }
        }
      if (GET_CODE (x3) == SUBREG)
        {
          res = recog_51 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == CONST_INT
          && XWINT (x4, 0) == 2147483647L)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && GET_MODE (x2) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 5182 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2022; /* *llgt_sisi */
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && nonimmediate_operand (operands[1], E_DImode)
                  && 
#line 5193 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2023; /* *llgt_didi */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern158 (x2))
        {
        case 0:
          if (!
#line 7954 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2342; /* *anddi3 */

        case 1:
          if (
#line 8083 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2353; /* *andsi3_zarch */
            }
          if (!
#line 8117 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2354; /* *andsi3_esa */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern66 (x2, 
E_DImode) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      if (!contiguous_bitmask_operand (operands[3], E_DImode))
        return -1;
      if (
#line 4397 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
        return 1944; /* *risbgn_di_and_rot */
      if (pnum_clobbers == NULL
          || !
#line 4397 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
        return -1;
      *pnum_clobbers = 1;
      return 1945; /* *risbg_di_and_rot */

    case LSHIFTRT:
      switch (pattern116 (x2))
        {
        case 0:
          if ((
#line 8004 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 2343; /* *extzv_di_srl_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 8004 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2344; /* *extzv_di_srl_clobbercc */

        case 1:
          if (
#line 8004 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return 2345; /* *extzv_si_srl_nocc */
          if (pnum_clobbers == NULL
              || !
#line 8004 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          *pnum_clobbers = 1;
          return 2346; /* *extzv_si_srl_clobbercc */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern116 (x2))
        {
        case 0:
          if ((
#line 8018 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 2347; /* *extzv_di_sll_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 8018 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2348; /* *extzv_di_sll_clobbercc */

        case 1:
          if (
#line 8018 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return 2349; /* *extzv_si_sll_nocc */
          if (pnum_clobbers == NULL
              || !
#line 8018 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          *pnum_clobbers = 1;
          return 2350; /* *extzv_si_sll_clobbercc */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x2) != E_DImode
                  || GET_MODE (x3) != E_DImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && (
#line 8226 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2359; /* *andc_split_di */
                }
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode)
                  || !(
#line 8605 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2381; /* *andcdi */

            case E_SImode:
              if (GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_SImode)
                  && nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && 
#line 8226 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))))
                {
                  *pnum_clobbers = 1;
                  return 2360; /* *andc_split_si */
                }
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 8605 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              *pnum_clobbers = 1;
              return 2383; /* *andcsi */

            default:
              return -1;
            }

        case NOT:
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern130 (x2, 
E_DImode) != 0
                  || !(
#line 8645 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2393; /* *nordi */

            case E_SImode:
              if (pattern130 (x2, 
E_SImode) != 0
                  || !
#line 8645 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              *pnum_clobbers = 1;
              return 2395; /* *norsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern65 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 860; /* xorv1qi3 */
          break;

        case 1:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 861; /* xorv2qi3 */
          break;

        case 2:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 862; /* xorv4qi3 */
          break;

        case 3:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 863; /* xorv8qi3 */
          break;

        case 4:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 864; /* xorv16qi3 */
          break;

        case 5:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 865; /* xorv1hi3 */
          break;

        case 6:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 866; /* xorv2hi3 */
          break;

        case 7:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 867; /* xorv4hi3 */
          break;

        case 8:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 868; /* xorv8hi3 */
          break;

        case 9:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 869; /* xorv1si3 */
          break;

        case 10:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 870; /* xorv2si3 */
          break;

        case 11:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 871; /* xorv4si3 */
          break;

        case 12:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 872; /* xorv1di3 */
          break;

        case 13:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 873; /* xorv2di3 */
          break;

        case 14:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 874; /* xorv1sf3 */
          break;

        case 15:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 875; /* xorv2sf3 */
          break;

        case 16:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 876; /* xorv4sf3 */
          break;

        case 17:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 877; /* xorv1df3 */
          break;

        case 18:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 878; /* xorv2df3 */
          break;

        case 19:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 879; /* xorv1tf3 */
          break;

        case 20:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 880; /* xorv1ti3 */
          break;

        case 21:
          if (
#line 1296 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 881; /* xorti3 */
          break;

        case 22:
          if (
#line 8785 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2402; /* *xordi3 */
            }
          break;

        case 23:
          if (
#line 8888 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2406; /* *xorhi3 */
            }
          break;

        case 24:
          if (
#line 8918 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2407; /* *xorqi3 */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern131 (x3) == 0
          && 
#line 4785 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 1997; /* *rxsbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode)
          || !
#line 8855 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2405; /* *xorsi3 */

    case AND:
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_V1QImode:
                  if (pattern8 (x3, 
E_V1QImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1579; /* *vevalv1qi_xorand */

                case E_V2QImode:
                  if (pattern8 (x3, 
E_V2QImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1588; /* *vevalv2qi_xorand */

                case E_V4QImode:
                  if (pattern8 (x3, 
E_V4QImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1597; /* *vevalv4qi_xorand */

                case E_V8QImode:
                  if (pattern8 (x3, 
E_V8QImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1606; /* *vevalv8qi_xorand */

                case E_V16QImode:
                  if (pattern8 (x3, 
E_V16QImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1615; /* *vevalv16qi_xorand */

                case E_V1HImode:
                  if (pattern8 (x3, 
E_V1HImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1624; /* *vevalv1hi_xorand */

                case E_V2HImode:
                  if (pattern8 (x3, 
E_V2HImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1633; /* *vevalv2hi_xorand */

                case E_V4HImode:
                  if (pattern8 (x3, 
E_V4HImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1642; /* *vevalv4hi_xorand */

                case E_V8HImode:
                  if (pattern8 (x3, 
E_V8HImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1651; /* *vevalv8hi_xorand */

                case E_V1SImode:
                  if (pattern8 (x3, 
E_V1SImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1660; /* *vevalv1si_xorand */

                case E_V2SImode:
                  if (pattern8 (x3, 
E_V2SImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1669; /* *vevalv2si_xorand */

                case E_V4SImode:
                  if (pattern8 (x3, 
E_V4SImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1678; /* *vevalv4si_xorand */

                case E_V1DImode:
                  if (pattern8 (x3, 
E_V1DImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1687; /* *vevalv1di_xorand */

                case E_V2DImode:
                  if (pattern8 (x3, 
E_V2DImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1696; /* *vevalv2di_xorand */

                case E_V1TImode:
                  if (pattern8 (x3, 
E_V1TImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1705; /* *vevalv1ti_xorand */

                case E_TImode:
                  if (pattern8 (x3, 
E_TImode) != 0
                      || !
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1714; /* *vevalti_xorand */

                default:
                  return -1;
                }

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern189 (x3, 
E_DImode) != 0
                      || !(
#line 4678 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1975; /* *rxsbg_di_noshift */

                case E_SImode:
                  if (pattern189 (x3, 
E_SImode) != 0
                      || !
#line 4678 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1977; /* *rxsbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ROTATE:
          if (pattern60 (x3, pnum_clobbers) != 0
              || !contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[4] = x5;
          if (!nonimmediate_operand (operands[4], E_DImode)
              || !
#line 4693 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1979; /* *rxsbg_di_rotl */

        case LSHIFTRT:
          switch (pattern86 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4708 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1981; /* *rxsbg_di_srl_bitmask */

            case 1:
              if (!
#line 4708 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 1983; /* *rxsbg_si_srl_bitmask */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern86 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4728 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1985; /* *rxsbg_di_sll_bitmask */

            case 1:
              if (!
#line 4728 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 1987; /* *rxsbg_si_sll_bitmask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1580; /* *vevalv1qi_xorior */

        case 1:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1589; /* *vevalv2qi_xorior */

        case 2:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1598; /* *vevalv4qi_xorior */

        case 3:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1607; /* *vevalv8qi_xorior */

        case 4:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1616; /* *vevalv16qi_xorior */

        case 5:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1625; /* *vevalv1hi_xorior */

        case 6:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1634; /* *vevalv2hi_xorior */

        case 7:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1643; /* *vevalv4hi_xorior */

        case 8:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1652; /* *vevalv8hi_xorior */

        case 9:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1661; /* *vevalv1si_xorior */

        case 10:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1670; /* *vevalv2si_xorior */

        case 11:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1679; /* *vevalv4si_xorior */

        case 12:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1688; /* *vevalv1di_xorior */

        case 13:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1697; /* *vevalv2di_xorior */

        case 14:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1706; /* *vevalv1ti_xorior */

        case 15:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1715; /* *vevalti_xorior */

        default:
          return -1;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1581; /* *vevalv1qi_xorxor */

        case 1:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1590; /* *vevalv2qi_xorxor */

        case 2:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1599; /* *vevalv4qi_xorxor */

        case 3:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1608; /* *vevalv8qi_xorxor */

        case 4:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1617; /* *vevalv16qi_xorxor */

        case 5:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1626; /* *vevalv1hi_xorxor */

        case 6:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1635; /* *vevalv2hi_xorxor */

        case 7:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1644; /* *vevalv4hi_xorxor */

        case 8:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1653; /* *vevalv8hi_xorxor */

        case 9:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1662; /* *vevalv1si_xorxor */

        case 10:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1671; /* *vevalv2si_xorxor */

        case 11:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1680; /* *vevalv4si_xorxor */

        case 12:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1689; /* *vevalv1di_xorxor */

        case 13:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1698; /* *vevalv2di_xorxor */

        case 14:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1707; /* *vevalv1ti_xorxor */

        case 15:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1716; /* *vevalti_xorxor */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern31 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4746 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1989; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4746 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1991; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern31 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4765 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1993; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4765 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1995; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) == E_CCL1mode)
    {
      x9 = XEXP (x7, 1);
      if (GET_MODE (x9) == E_CCL1mode)
        {
          x10 = XEXP (x9, 1);
          if (rtx_equal_p (x10, operands[1]))
            {
              x11 = XEXP (x9, 0);
              switch (GET_MODE (x11))
                {
                case E_DImode:
                  if (pattern275 (x3, 
E_DImode) == 0
                      && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2199; /* adddi3_carry1_cc */
                  break;

                case E_SImode:
                  if (pattern275 (x3, 
E_SImode) == 0)
                    return 2200; /* addsi3_carry1_cc */
                  break;

                default:
                  break;
                }
            }
        }
    }
  x9 = XEXP (x7, 1);
  x11 = XEXP (x9, 0);
  switch (GET_MODE (x11))
    {
    case E_DImode:
      if (pattern254 (x1, 
E_DImode) != 0
          || !(
#line 6276 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2203; /* *adddi3_carry2_cc */

    case E_SImode:
      if (pattern254 (x1, 
E_SImode) != 0
          || !
#line 6276 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
        return -1;
      return 2204; /* *addsi3_carry2_cc */

    case E_TFmode:
      if (pattern255 (x1, 
E_TFmode) != 0
          || !(
#line 6503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2226; /* *addtf3_cc */

    case E_FPRX2mode:
      if (pattern255 (x1, 
E_FPRX2mode) != 0
          || !(
#line 6503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2227; /* *addfprx23_cc */

    case E_DFmode:
      if (pattern255 (x1, 
E_DFmode) != 0
          || !
#line 6503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
        return -1;
      return 2228; /* *adddf3_cc */

    case E_SFmode:
      if (pattern255 (x1, 
E_SFmode) != 0
          || !
#line 6503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
        return -1;
      return 2229; /* *addsf3_cc */

    case E_TDmode:
      if (pattern255 (x1, 
E_TDmode) != 0
          || !(
#line 6503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2230; /* *addtd3_cc */

    case E_DDmode:
      if (pattern255 (x1, 
E_DDmode) != 0
          || !(
#line 6503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2231; /* *adddd3_cc */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (s390_signed_integer_comparison (operands[0], E_VOIDmode))
    {
      switch (pattern118 (x1))
        {
        case 0:
          if ((
#line 1637 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 1801; /* *cmp_and_br_signed_di */
          break;

        case 1:
          if (
#line 1637 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return 1802; /* *cmp_and_br_signed_si */
          break;

        case 2:
          if ((
#line 1695 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 1805; /* *icmp_and_br_signed_di */
          break;

        case 3:
          if (
#line 1695 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return 1806; /* *icmp_and_br_signed_si */
          break;

        default:
          break;
        }
    }
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x3, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  switch (GET_CODE (x4))
    {
    case GT:
    case LE:
      if (pnum_clobbers == NULL
          || !s390_brx_operator (x4, E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != PLUS)
        return -1;
      x10 = XEXP (x8, 0);
      operands[1] = x10;
      x11 = XEXP (x5, 0);
      operands[0] = x11;
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      operands[6] = x4;
      res = recog_89 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x13 = XEXP (x8, 1);
      if (GET_CODE (x13) != SUBREG)
        return -1;
      x14 = XEXP (x4, 1);
      if (GET_CODE (x14) != SUBREG)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != SUBREG)
        return -1;
      operands[5] = x4;
      x16 = XEXP (x13, 0);
      operands[2] = x16;
      x17 = XEXP (x7, 0);
      operands[3] = x17;
      x18 = XEXP (x14, 0);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      x19 = XEXP (x15, 0);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      switch (SUBREG_BYTE (x13))
        {
        case 0:
          if (maybe_ne (SUBREG_BYTE (x15), 0))
            return -1;
          switch (SUBREG_BYTE (x14))
            {
            case 8:
              if (pattern297 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 10064 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 2;
              return 2535; /* *brxg_64bit */

            case 4:
              if (pattern297 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 10150 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 2;
              return 2537; /* *brx_31bit */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x13) != E_SImode
              || maybe_ne (SUBREG_BYTE (x14), 12)
              || GET_MODE (x14) != E_SImode
              || maybe_ne (SUBREG_BYTE (x15), 4)
              || GET_MODE (x15) != E_SImode
              || GET_MODE (x8) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_TImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || GET_MODE (x9) != E_SImode
              || !
#line 10107 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 2;
          return 2536; /* *brx_64bit */

        default:
          return -1;
        }

    case NE:
    case EQ:
      if (pnum_clobbers != NULL)
        {
          res = recog_90 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x4;
      if (!s390_eqne_operator (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 33
          || GET_MODE (x8) != E_CCRAWmode
          || pattern232 (x1) != 0)
        return -1;
      return 2647; /* *ccraw_to_int */

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_CCmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pattern214 (x5, 
E_DImode) != 0
          || !
#line 7409 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2308; /* *muldi3 */

    case E_SImode:
      if (pattern214 (x5, 
E_SImode) != 0)
        return -1;
      return 2313; /* *mulsi3 */

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case NEG:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          operands[1] = x5;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (pattern224 (x6, 
E_DImode) != 0
                  || !(
#line 6354 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2211; /* *adddi3_cconly2 */

            case E_SImode:
              if (pattern224 (x6, 
E_SImode) != 0
                  || !
#line 6354 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)))
                return -1;
              return 2212; /* *addsi3_cconly2 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[0] = x5;
          res = recog_80 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          operands[2] = x6;
          operands[1] = x5;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case SET:
              x10 = XEXP (x7, 1);
              if (GET_CODE (x10) != MINUS)
                return -1;
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              x11 = XEXP (x10, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              x12 = XEXP (x10, 1);
              if (!rtx_equal_p (x12, operands[2]))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (pattern252 (x10, 
E_DImode) != 0
                      || !(
#line 6828 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2253; /* *subdi3_cc2 */

                case E_SImode:
                  if (pattern252 (x10, 
E_SImode) != 0
                      || !
#line 6828 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
                    return -1;
                  return 2254; /* *subsi3_cc2 */

                default:
                  return -1;
                }

            case CLOBBER:
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!register_operand (operands[1], E_DImode)
                      || !general_operand (operands[2], E_DImode)
                      || !scratch_operand (operands[0], E_DImode)
                      || !(
#line 6862 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2257; /* *subdi3_cconly2 */

                case E_SImode:
                  if (!register_operand (operands[1], E_SImode)
                      || !general_operand (operands[2], E_SImode)
                      || !scratch_operand (operands[0], E_SImode)
                      || !
#line 6862 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
                    return -1;
                  return 2258; /* *subsi3_cconly2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case ASHIFT:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != SUBREG
              || maybe_ne (SUBREG_BYTE (x14), 0)
              || GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x13, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x16 = XEXP (x5, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x10 = XEXP (x7, 1);
          if (GET_CODE (x10) != SIGN_EXTEND
              || GET_MODE (x10) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x9 = XEXP (x7, 0);
          if (!register_operand (x9, E_DImode))
            return -1;
          x17 = XEXP (x14, 0);
          switch (GET_CODE (x17))
            {
            case REG:
            case SUBREG:
            case MEM:
              operands[0] = x17;
              if (!nonimmediate_operand (operands[0], E_SImode))
                return -1;
              x6 = XEXP (x4, 1);
              operands[1] = x6;
              if (!const0_operand (operands[1], E_DImode))
                return -1;
              operands[2] = x9;
              x11 = XEXP (x10, 0);
              if (!rtx_equal_p (x11, operands[0])
                  || !
#line 1077 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_ZARCH))
                return -1;
              return 1738; /* *tstdi_sign */

            case UNSPEC:
              if (XVECLEN (x17, 0) != 1
                  || XINT (x17, 1) != 4
                  || GET_MODE (x17) != E_SImode)
                return -1;
              x6 = XEXP (x4, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || pattern294 (x1) != 0)
                return -1;
              operands[0] = x9;
              x11 = XEXP (x10, 0);
              x18 = XVECEXP (x11, 0, 0);
              if (!rtx_equal_p (x18, operands[1])
                  || !
#line 4221 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_ZARCH))
                return -1;
              return 1916; /* *cmpint_sign_cc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x13;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x16 = XEXP (x5, 1);
          operands[2] = x16;
          if (!shift_count_operand (operands[2], E_QImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              switch (pattern192 (x1))
                {
                case 0:
                  if ((
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9727 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
                    return 2511; /* *ashrdi3_31_cconly */
                  if (!(
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2514; /* *ashrdi3_cconly */

                case 1:
                  if (!
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
                    return -1;
                  return 2517; /* *ashrsi3_cconly */

                default:
                  return -1;
                }

            case SET:
              x10 = XEXP (x7, 1);
              if (GET_CODE (x10) != ASHIFTRT)
                return -1;
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              x11 = XEXP (x10, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              x12 = XEXP (x10, 1);
              if (!rtx_equal_p (x12, operands[2]))
                return -1;
              switch (pattern239 (x1))
                {
                case 0:
                  if ((
#line 31 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9727 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
                    return 2512; /* *ashrdi3_31_cc */
                  if (!(
#line 31 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2515; /* *ashrdi3_cc */

                case 1:
                  if (!
#line 31 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
                    return -1;
                  return 2518; /* *ashrsi3_cc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 4
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET
          || pattern212 (x1) != 0)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x7, 1);
      x19 = XVECEXP (x10, 0, 0);
      if (!rtx_equal_p (x19, operands[1])
          || !
#line 4186 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)))
        return -1;
      return 1914; /* *cmpint_cc */

    case IOR:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case AND:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x16 = XEXP (x5, 1);
          if (GET_CODE (x16) != AND
              || GET_MODE (x16) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          operands[1] = x14;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x15 = XEXP (x13, 1);
          operands[2] = x15;
          if (!contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x20 = XEXP (x16, 0);
          operands[3] = x20;
          if (!nonimmediate_operand (operands[3], E_DImode))
            return -1;
          x21 = XEXP (x16, 1);
          operands[4] = x21;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case SET:
              x10 = XEXP (x7, 1);
              if (pattern253 (x10, 
AND, 
IOR) != 0)
                return -1;
              x12 = XEXP (x10, 1);
              if (GET_CODE (x12) != AND
                  || GET_MODE (x12) != E_DImode)
                return -1;
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              if (!nonimmediate_operand (operands[0], E_DImode))
                return -1;
              x11 = XEXP (x10, 0);
              x22 = XEXP (x11, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x23 = XEXP (x11, 1);
              if (!rtx_equal_p (x23, operands[2]))
                return -1;
              x24 = XEXP (x12, 0);
              if (!rtx_equal_p (x24, operands[3]))
                return -1;
              x25 = XEXP (x12, 1);
              if (!rtx_equal_p (x25, operands[4])
                  || !
#line 4514 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                return -1;
              return 1958; /* *insv_z10_noshift_cc */

            case CLOBBER:
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              if (!scratch_operand (operands[0], E_DImode)
                  || !
#line 4533 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                return -1;
              return 1959; /* *insv_z10_noshift_cconly */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern147 (x1, 
IOR))
            {
            case 0:
              if (!
#line 8331 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              return 2362; /* *iordi3_cc */

            case 1:
              if (!
#line 8411 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2365; /* *iorsi3_cc */

            case 2:
              if (!
#line 8346 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              return 2363; /* *iordi3_cconly */

            case 3:
              if (!
#line 8428 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2366; /* *iorsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern163 (x1, 
IOR))
            {
            case 0:
              if (!(
#line 8583 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2374; /* *orcdi_cc */

            case 1:
              if (!
#line 8583 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2376; /* *orcsi_cc */

            case 2:
              if (!(
#line 8595 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2378; /* *orcdi_cconly */

            case 3:
              if (!
#line 8595 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2380; /* *orcsi_cconly */

            case 4:
              if (!(
#line 8623 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2386; /* *nanddi_cc */

            case 5:
              if (!
#line 8623 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2388; /* *nandsi_cc */

            case 6:
              if (!(
#line 8635 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2390; /* *nanddi_cconly */

            case 7:
              if (!
#line 8635 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2392; /* *nandsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      return recog_85 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_86 (x1, insn, pnum_clobbers);

    case MULT:
      x13 = XEXP (x5, 0);
      if (GET_CODE (x13) != SIGN_EXTEND)
        return -1;
      switch (pattern144 (x1, 
MULT))
        {
        case 0:
          if (pattern288 (x1, 
E_DImode, 
E_TImode) != 0
              || !(
#line 7539 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode) && TARGET_Z14) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2315; /* *mulvdi3_ccoverflow */

        case 1:
          if (pattern288 (x1, 
E_SImode, 
E_DImode) != 0
              || !
#line 7539 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode) && TARGET_Z14))
            return -1;
          return 2316; /* *mulvsi3_ccoverflow */

        default:
          return -1;
        }

    case AND:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern147 (x1, 
AND))
            {
            case 0:
              if (!
#line 7915 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2340; /* *anddi3_cc */

            case 1:
              if (!
#line 8039 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2351; /* *andsi3_cc */

            case 2:
              if (!
#line 7932 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], DImode, HImode, 0) < 0))
                return -1;
              return 2341; /* *anddi3_cconly */

            case 3:
              if (!
#line 8060 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], SImode, HImode, 0) < 0))
                return -1;
              return 2352; /* *andsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern163 (x1, 
AND))
            {
            case 0:
              if (!(
#line 8583 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2373; /* *andcdi_cc */

            case 1:
              if (!
#line 8583 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2375; /* *andcsi_cc */

            case 2:
              if (!(
#line 8595 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2377; /* *andcdi_cconly */

            case 3:
              if (!
#line 8595 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2379; /* *andcsi_cconly */

            case 4:
              if (!(
#line 8623 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2385; /* *nordi_cc */

            case 5:
              if (!
#line 8623 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2387; /* *norsi_cc */

            case 6:
              if (!(
#line 8635 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2389; /* *nordi_cconly */

            case 7:
              if (!
#line 8635 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2391; /* *norsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern147 (x1, 
XOR))
        {
        case 0:
          if (!
#line 8756 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          return 2400; /* *xordi3_cc */

        case 1:
          if (!
#line 8820 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          return 2403; /* *xorsi3_cc */

        case 2:
          if (!
#line 8771 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          return 2401; /* *xordi3_cconly */

        case 3:
          if (!
#line 8838 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          return 2404; /* *xorsi3_cconly */

        default:
          return -1;
        }

    case NOT:
      x13 = XEXP (x5, 0);
      if (GET_CODE (x13) != XOR)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      x15 = XEXP (x13, 1);
      operands[2] = x15;
      switch (pattern191 (x1, 
NOT, 
XOR))
        {
        case 0:
          x7 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x7, 1);
          x12 = XEXP (x10, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_DImode:
              if (pattern271 (x1, 
E_DImode) != 0
                  || !(
#line 9037 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2410; /* *nxordi_cc */

            case E_SImode:
              if (pattern271 (x1, 
E_SImode) != 0
                  || !
#line 9037 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2411; /* *nxorsi_cc */

            default:
              return -1;
            }

        case 1:
          if (pattern238 (x13, 
E_DImode) != 0
              || !(
#line 9049 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2412; /* *nxordi_cconly */

        case 2:
          if (pattern238 (x13, 
E_SImode) != 0
              || !
#line 9049 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          return 2413; /* *nxorsi_cconly */

        default:
          return -1;
        }

    case NEG:
      return recog_87 (x1, insn, pnum_clobbers);

    case ABS:
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case ASHIFTRT:
          if (pattern148 (x1, 
ABS) != 0
              || !
#line 9288 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2443; /* *absdi2_sign_cc */

        case REG:
        case SUBREG:
          operands[1] = x13;
          x6 = XEXP (x4, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              res = recog_84 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[2] = x6;
          switch (pattern177 (x1, 
ABS))
            {
            case 0:
              if (!(
#line 9354 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2451; /* *abstf2_cc */

            case 1:
              if (!(
#line 9354 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2452; /* *absfprx22_cc */

            case 2:
              if (!
#line 9354 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              return 2453; /* *absdf2_cc */

            case 3:
              if (!
#line 9354 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              return 2454; /* *abssf2_cc */

            case 4:
              if (!(
#line 9365 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2455; /* *abstf2_cconly */

            case 5:
              if (!(
#line 9365 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2456; /* *absfprx22_cconly */

            case 6:
              if (!
#line 9365 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              return 2457; /* *absdf2_cconly */

            case 7:
              if (!
#line 9365 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              return 2458; /* *abssf2_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case POPCOUNT:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x5, 0);
      operands[1] = x13;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case SET:
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x10 = XEXP (x7, 1);
          if (!rtx_equal_p (x10, operands[1])
              || !
#line 12086 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode (insn, CCTmode)))
            return -1;
          return 2634; /* *popcountdi_z15_cc */

        case CLOBBER:
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!scratch_operand (operands[0], E_DImode)
              || !
#line 12095 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          return 2635; /* *popcountdi_z15_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case VEC_SELECT:
      switch (pattern36 (x1))
        {
        case 0:
          if (!(
#line 1007 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1012 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
            return NULL;
          return gen_split_44 (insn, operands);

        case 1:
          if (!(
#line 1077 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1082 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
            return NULL;
          return gen_split_46 (insn, operands);

        case 2:
          if (!(
#line 1077 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1082 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
            return NULL;
          return gen_split_47 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return NULL;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!permute_pattern_operand (operands[2], E_V16QImode))
        return NULL;
      switch (pattern164 (x3))
        {
        case 0:
          if (!(
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3335 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V8HImode)
   && !memory_operand (operands[1], V8HImode))))
            return NULL;
          return gen_split_132 (insn, operands);

        case 1:
          if (!(
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3335 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V4SImode)
   && !memory_operand (operands[1], V4SImode))))
            return NULL;
          return gen_split_133 (insn, operands);

        case 2:
          if (!(
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3335 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V4SFmode)
   && !memory_operand (operands[1], V4SFmode))))
            return NULL;
          return gen_split_134 (insn, operands);

        case 3:
          if (!(
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3335 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V2DImode)
   && !memory_operand (operands[1], V2DImode))))
            return NULL;
          return gen_split_135 (insn, operands);

        case 4:
          if (!(
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3335 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V2DFmode)
   && !memory_operand (operands[1], V2DFmode))))
            return NULL;
          return gen_split_136 (insn, operands);

        case 5:
          if (!(
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3335 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V1TImode)
   && !memory_operand (operands[1], V1TImode))))
            return NULL;
          return gen_split_137 (insn, operands);

        case 6:
          if (!(
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3335 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V1TFmode)
   && !memory_operand (operands[1], V1TFmode))))
            return NULL;
          return gen_split_138 (insn, operands);

        case 7:
          if (!(
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3335 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], TImode)
   && !memory_operand (operands[1], TImode))))
            return NULL;
          return gen_split_139 (insn, operands);

        case 8:
          if (!(
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3335 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], TFmode)
   && !memory_operand (operands[1], TFmode))))
            return NULL;
          return gen_split_140 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      if (pattern38 (x1) != 0)
        return NULL;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          x8 = XEXP (x3, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              if (GET_CODE (x8) == CONST_INT
                  && XWINT (x8, 0) == 2147483647L
                  && register_operand (operands[0], E_SImode)
                  && GET_MODE (x3) == E_SImode)
                {
                  operands[1] = x6;
                  if (address_operand (operands[1], E_QImode)
                      && (
#line 2582 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT) && 
#line 2584 "../../gcc/config/s390/s390.md"
( reload_completed)))
                    return gen_split_298 (insn, operands);
                  if (nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5205 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed))
                    return gen_split_350 (insn, operands);
                }
              operands[1] = x8;
              if (rtx_equal_p (x6, operands[0]))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (s_operand (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode
                          && immediate_operand (operands[1], E_SImode)
                          && 
#line 8131 "../../gcc/config/s390/s390.md"
(reload_completed))
                        return gen_split_366 (insn, operands);
                      break;

                    case E_HImode:
                      if (s_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode
                          && immediate_operand (operands[1], E_HImode)
                          && 
#line 8176 "../../gcc/config/s390/s390.md"
(reload_completed))
                        return gen_split_367 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case SUBREG:
            case MEM:
              operands[1] = x8;
              if (memory_operand (operands[1], E_VOIDmode)
                  && memory_operand (operands[0], E_VOIDmode)
                  && rtx_equal_p (x6, operands[0])
                  && 
#line 8268 "../../gcc/config/s390/s390.md"
(reload_completed
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
                return gen_split_370 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x8) == CONST_INT
              && XWINT (x8, 0) == 2147483647L
              && register_operand (operands[0], E_DImode)
              && GET_MODE (x3) == E_DImode)
            {
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 0)
                  && GET_MODE (x6) == E_DImode)
                {
                  x9 = XEXP (x6, 0);
                  operands[1] = x9;
                  if (memory_operand (operands[1], E_SImode)
                      && (
#line 5170 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 5172 "../../gcc/config/s390/s390.md"
( reload_completed)))
                    return gen_split_348 (insn, operands);
                }
              operands[1] = x6;
              if (nonimmediate_operand (operands[1], E_DImode)
                  && 
#line 5205 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed))
                return gen_split_349 (insn, operands);
            }
          if (!rtx_equal_p (x6, operands[0])
              || !s_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return NULL;
          operands[1] = x8;
          if (!immediate_operand (operands[1], E_DImode)
              || !
#line 7991 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_365 (insn, operands);

        case NOT:
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern231 (x3, 
E_DImode) != 0
                  || !((
#line 8226 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 8233 "../../gcc/config/s390/s390.md"
( 1)))
                return NULL;
              return gen_split_368 (insn, operands);

            case E_SImode:
              if (pattern231 (x3, 
E_SImode) != 0
                  || !(
#line 8226 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 8233 "../../gcc/config/s390/s390.md"
( 1)))
                return NULL;
              return gen_split_369 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 4
          || pattern102 (x1) != 0)
        return NULL;
      x10 = XVECEXP (x3, 0, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_CCUmode)
          || !
#line 4173 "../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_334 (insn, operands);

    case COMPARE:
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 33)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return NULL;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case UNSPEC:
          if (XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 4
              || GET_MODE (x6) != E_SImode
              || pattern212 (x1) != 0
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x11 = XEXP (x4, 1);
          x12 = XVECEXP (x11, 0, 0);
          if (!rtx_equal_p (x12, operands[1])
              || !(
#line 4186 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)) && 
#line 4188 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_335 (insn, operands);

        case ASHIFTRT:
          if (GET_MODE (x6) != E_DImode)
            return NULL;
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != ASHIFT
              || GET_MODE (x9) != E_DImode)
            return NULL;
          x13 = XEXP (x9, 0);
          if (GET_CODE (x13) != SUBREG
              || maybe_ne (SUBREG_BYTE (x13), 0)
              || GET_MODE (x13) != E_DImode)
            return NULL;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != UNSPEC
              || XVECLEN (x14, 0) != 1
              || XINT (x14, 1) != 4
              || GET_MODE (x14) != E_SImode)
            return NULL;
          x15 = XEXP (x9, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return NULL;
          x16 = XEXP (x6, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return NULL;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != SIGN_EXTEND
              || GET_MODE (x11) != E_DImode
              || pattern294 (x1) != 0
              || !register_operand (operands[0], E_DImode))
            return NULL;
          x17 = XEXP (x11, 0);
          x18 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x18, operands[1])
              || !(
#line 4221 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_ZARCH) && 
#line 4223 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_337 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      x19 = XEXP (x3, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern72 (x1))
        {
        case 0:
          if (!((
#line 4408 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 4410 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_338 (insn, operands);

        case 1:
          if (!(
#line 4408 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 4410 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_339 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      x19 = XEXP (x3, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern72 (x1))
        {
        case 0:
          if (!(
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 4435 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_340 (insn, operands);

        case 1:
          if (!
#line 4435 "../../gcc/config/s390/s390.md"
( reload_completed))
            return NULL;
          return gen_split_341 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      if (pattern38 (x1) != 0)
        return NULL;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case LSHIFTRT:
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != ASHIFT)
            return NULL;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          x16 = XEXP (x6, 1);
          operands[2] = x16;
          x20 = XEXP (x8, 0);
          operands[3] = x20;
          x21 = XEXP (x8, 1);
          operands[4] = x21;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern259 (x3, 
E_DImode) != 0
                  || !(
#line 4650 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 64) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return NULL;
              return gen_split_344 (insn, operands);

            case E_SImode:
              if (pattern259 (x3, 
E_SImode) != 0
                  || !
#line 4650 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 32))
                return NULL;
              return gen_split_345 (insn, operands);

            default:
              return NULL;
            }

        case SUBREG:
        case MEM:
          if (!rtx_equal_p (x6, operands[0]))
            return NULL;
          x8 = XEXP (x3, 1);
          operands[1] = x8;
          switch (pattern195 (x3))
            {
            case 0:
              if (!
#line 8394 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_371 (insn, operands);

            case 1:
              if (!
#line 8485 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_372 (insn, operands);

            case 2:
              if (!
#line 8528 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_373 (insn, operands);

            case 3:
              if (!
#line 8678 "../../gcc/config/s390/s390.md"
(reload_completed
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
                return NULL;
              return gen_split_374 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      switch (pattern46 (x1))
        {
        case 0:
          if (pattern214 (x3, 
E_TImode) != 0
              || !(
#line 6065 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 6067 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_354 (insn, operands);

        case 1:
          if (pattern121 (x3, 
E_DImode) != 0
              || !(
#line 6156 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 6158 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_355 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      switch (pattern46 (x1))
        {
        case 0:
          if (pattern219 (x3, 
E_TImode) != 0
              || !(
#line 6612 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 6614 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_356 (insn, operands);

        case 1:
          if (pattern219 (x3, 
E_DImode) != 0
              || !(
#line 6703 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 6705 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_357 (insn, operands);

        default:
          return NULL;
        }

    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      if (pattern38 (x1) != 0)
        return NULL;
      switch (GET_CODE (x3))
        {
        case SIGN_EXTEND:
          switch (pattern182 (x3))
            {
            case 0:
              if ((
#line 4204 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 4206 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_336 (insn, operands);
              break;

            case 1:
              if (((
#line 5105 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 5107 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_346 (insn, operands);
              break;

            case 2:
              if ((
#line 5105 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 5107 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_347 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case ZERO_EXTEND:
          if (GET_MODE (x3) == E_SImode
              && register_operand (operands[0], E_SImode))
            {
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (s_operand (operands[1], E_HImode)
                  && (
#line 5290 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5292 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_351 (insn, operands);
            }
          break;

        default:
          break;
        }
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return NULL;
          if (s390_alc_comparison (operands[1], E_DImode)
              && (
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 7197 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return gen_split_358 (insn, operands);
          if (!s390_slb_comparison (operands[1], E_DImode)
              || !(
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 7211 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_360 (insn, operands);

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          if (s390_alc_comparison (operands[1], E_SImode)
              && 
#line 7197 "../../gcc/config/s390/s390.md"
( reload_completed))
            return gen_split_359 (insn, operands);
          if (!s390_slb_comparison (operands[1], E_SImode)
              || !
#line 7211 "../../gcc/config/s390/s390.md"
( reload_completed))
            return NULL;
          return gen_split_361 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern39 (x4) != 0)
        return NULL;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_CCZ1mode)
          || !
#line 7269 "../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_362 (insn, operands);

    case XOR:
      if (pattern38 (x1) != 0)
        return NULL;
      x8 = XEXP (x3, 1);
      operands[1] = x8;
      x6 = XEXP (x3, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return NULL;
      switch (pattern195 (x3))
        {
        case 0:
          if (!
#line 8803 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_379 (insn, operands);

        case 1:
          if (!
#line 8873 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_380 (insn, operands);

        case 2:
          if (!
#line 8903 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_381 (insn, operands);

        case 3:
          if (!
#line 8950 "../../gcc/config/s390/s390.md"
(reload_completed
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
            return NULL;
          return gen_split_382 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      if (pattern40 (x1) != 0)
        return NULL;
      if (
#line 9151 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && reload_completed
   && ((REG_P (operands[0]) && REG_P (operands[1])
       && REGNO (operands[0]) == REGNO (operands[1]))
      || s390_split_ok_p (operands[0], operands[1], DImode, 0))))
        return gen_split_383 (insn, operands);
      if (!
#line 9184 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && s390_split_ok_p (operands[0], operands[1], DImode, 1)
   && reload_completed))
        return NULL;
      return gen_split_384 (insn, operands);

    case IF_THEN_ELSE:
      x6 = XEXP (x3, 0);
      if (!s390_eqne_operator (x6, E_VOIDmode))
        return NULL;
      operands[0] = x6;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 33
          || GET_MODE (x9) != E_CCRAWmode)
        return NULL;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != LABEL_REF)
        return NULL;
      x19 = XEXP (x3, 2);
      if (GET_CODE (x19) != PC)
        return NULL;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != PC)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET
          || pattern232 (x1) != 0)
        return NULL;
      return gen_split_393 (insn, operands);

    default:
      return NULL;
    }
}
